#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "data.h"
#include "engine.h"
#include "version.h"


int was_st_found;
int which_select;

GtkWidget *r_clist;
GtkWidget *w_entry;
GtkWidget *statusbar1;

GtkWidget *options_dialog;                                                           


void insert_to_clist(char * en, char * cs)
{
  char *item[2];
  item[0]=malloc(30);
  item[1]=malloc(30);

  strcpy(item[0],en);
  strcpy(item[1],cs);

  gtk_clist_append(GTK_CLIST(r_clist), item);
 
  free(item[0]);
  free(item[1]);
}


/****************************************************************************/
void  seek_for_word(char *string, tdatabase *d, tindex *index)
/****************************************************************************/
{
  int i=0;
  char * column_0=NULL;
  char * column_1=NULL;
  char first_letter=string[0];

  was_st_found=0;
  
  gtk_clist_clear(GTK_CLIST(r_clist));

//  i=index->index_table[(int)string[0]];
  i = get_start(first_letter, index);
  
  for (; i<d->dbfheader.RecordNumber; i++) {
    seek_to_row(i, d);
    column_0=get_column(0);
    column_1=get_column(1);

    if (column_0[0]>first_letter) {
      free(column_1);
      free(column_0);
      return;
    }  
    if (!strncmp(column[0],string, strlen(string))) {
//      printf("found: %s - %s\n", column[0], column[1]);
      insert_to_clist(column[0],column[1]);
      was_st_found=1;
    }  
  }
  free(column_1);
  free(column_0);

}

/****************************************************************************/
void seek_control()
/****************************************************************************/
{
  gchar *entry_text;
  tdatabase d;
  tindex index;

  entry_text = gtk_entry_get_text(GTK_ENTRY(w_entry));

#ifdef DEBUG
  printf("Entry contents: %s\n", entry_text);
#endif

  read_translation_table(translate_table, &d);
  read_index_table(database_index, &index);
  if (!open_database(database_file, &d)) return;
  if (use_database(&d)) {
    seek_for_word(entry_text, &d, &index);
  } else {
    printf ("use error\n");
  }  
  close_database(&d);
}

/*****************************************************************************/
void action_after_filesel(gchar * name)
/*****************************************************************************/
{
  GtkWidget * entry;

  switch (which_select) {
    case DATABASE: {
      printf ("select database ...\n");
      entry = lookup_widget (GTK_WIDGET (options_dialog), "database_entry");
      gtk_entry_set_text ((GtkEntry *)entry, name);
    } break;
    case INDEX: {
      printf ("select index ...\n");
      entry = lookup_widget (GTK_WIDGET (options_dialog), "index_entry");
      gtk_entry_set_text ((GtkEntry *)entry, name);
    } break;
    case CREATE_INDEX: {
      g_print("creating index (%s,%s) ...\n",database_file, name);
      if (!create_index(database_file, name)) {
        printf ("FAILED \n");
      }
      printf ("DONE \n");
      entry = lookup_widget (GTK_WIDGET (options_dialog), "index_entry");
      gtk_entry_set_text ((GtkEntry *)entry, name);
    } break;
    case TABLE: {
      printf ("select table ...\n"); 
      entry = lookup_widget (GTK_WIDGET (options_dialog), "table_entry");
      gtk_entry_set_text ((GtkEntry *)entry, name);
    } break;
  }  
}

void status_bar_result()
{
  gint context_id = gtk_statusbar_get_context_id( GTK_STATUSBAR(statusbar1), "Statusbar example");
  gtk_statusbar_pop( GTK_STATUSBAR(statusbar1), context_id );
  if (!was_st_found) gtk_statusbar_push( GTK_STATUSBAR(statusbar1), context_id, "Zadne slovo nenalezeno");
}

void on_button1_pressed  (GtkButton *button, gpointer user_data)
{
  w_entry = lookup_widget (GTK_WIDGET (button), "word_entry");
  r_clist = lookup_widget (GTK_WIDGET (button), "result_clist");
  statusbar1 = lookup_widget (GTK_WIDGET (button), "statusbar1");
  seek_control();
  status_bar_result();
}

void on_about_1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
  GtkWidget *about_window;
  GtkWidget *version_label;
  gchar * version_str;
  
  version_str=(gchar *)malloc(50);
  about_window = create_about_window ();
  version_label = lookup_widget (GTK_WIDGET (about_window), "version_label");
  sprintf(version_str,"%i.%i.%i build %i",version,subversion,modification,build);
  gtk_label_set((GtkLabel*)version_label,version_str);
  gtk_widget_show (about_window);  
}

void
on_word_entry_activate (GtkEditable *editable, gpointer user_data)
{
  w_entry = lookup_widget (GTK_WIDGET (editable), "word_entry");
  r_clist = lookup_widget (GTK_WIDGET (editable), "result_clist");
  statusbar1 = lookup_widget (GTK_WIDGET (editable), "statusbar1");
  printf("entry activated\n");
  seek_control();
  status_bar_result();
}

void
gtk_window_destroy                     (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_databaze1_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}

gboolean
on_fixed1_delete_event                 (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  return FALSE;
}

void
on_soubor1_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data){}

void
on_options1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
}

void
on_about_ok_pressed                    (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy (gtk_widget_get_toplevel (GTK_WIDGET (button)));
}


void
on_options_ok_button_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget * entry;
  gchar * pom_str;
  
  entry = lookup_widget (GTK_WIDGET (options_dialog), "database_entry");
  pom_str = gtk_entry_get_text ((GtkEntry *) entry);
  g_print("Database : %s\n",pom_str);
  set_database(pom_str);
  
  entry = lookup_widget (GTK_WIDGET (options_dialog), "index_entry");
  pom_str = gtk_entry_get_text ((GtkEntry *) entry);
  g_print("index : %s\n", pom_str);
  set_index(pom_str);
  
  entry = lookup_widget (GTK_WIDGET (options_dialog), "table_entry");
  pom_str = gtk_entry_get_text ((GtkEntry *) entry);
  g_print("Table : %s\n", pom_str);
  set_translate(pom_str);
  
  gtk_widget_destroy (gtk_widget_get_toplevel (GTK_WIDGET (button)));
}

/***************************************************************************
 * Open File Selection Dialog.
 ***************************************************************************/
void
on_open_filesel_ok_button_clicked           (GtkButton       *button,
					     gpointer         user_data)
{
  GtkWidget *filesel;
  gchar *filename;
  gchar *name;
  
  filesel = gtk_widget_get_toplevel (GTK_WIDGET (button));
  filename = gtk_file_selection_get_filename (GTK_FILE_SELECTION (filesel));
  name=(char *)malloc(250);
  strncpy(name, filename, 240);
  g_print("selected file (%s)\n",filename);
  gtk_widget_destroy (gtk_widget_get_toplevel (GTK_WIDGET (button)));
  
  action_after_filesel(name);
}


void
on_open_filesel_cancel_button_clicked       (GtkButton       *button,
					     gpointer         user_data)
{
  gtk_widget_destroy (gtk_widget_get_toplevel (GTK_WIDGET (button)));
}


void
on_vyber_databaze_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget* fileselection; 
  fileselection = create_fileselection1 (); 
  gtk_widget_show (fileselection);  
  g_print("show end\n");
  which_select=DATABASE;
}


void
on_vyber_index_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget* fileselection; 
  which_select=INDEX;
  fileselection = create_fileselection1 (); 
  gtk_widget_show (fileselection);  
  g_print("You want to select index ...\n");
}


void
on_vyber_k_tabulky_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget* fileselection; 
  which_select=TABLE;
  fileselection = create_fileselection1 (); 
  gtk_widget_show (fileselection);  
  g_print("You want to select table ...\n");
}


void
on_cancel_button_pressed               (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy (gtk_widget_get_toplevel (GTK_WIDGET (button)));
}


void
on_create_index_button_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget* fileselection; 
  fileselection = create_fileselection1 (); 
  which_select=CREATE_INDEX;
  gtk_widget_show (fileselection);  
  g_print("You want to create index ...\n");
}




void
on_save_as_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_properties1_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkEntry * entry;

  options_dialog = create_option_dialog();

  entry = lookup_widget (GTK_WIDGET (options_dialog),"database_entry");
  gtk_entry_set_text ((GtkEntry *) entry, database_file);

  entry = lookup_widget (GTK_WIDGET (options_dialog), "index_entry");
  gtk_entry_set_text ((GtkEntry *) entry, database_index);

  entry = lookup_widget (GTK_WIDGET (options_dialog), "table_entry");
  gtk_entry_set_text ((GtkEntry *) entry, translate_table);

  gtk_widget_show (options_dialog);  

}


void
on_save_options1_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}

