#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define COLUMN_LENGTH 200

char column[20][COLUMN_LENGTH];

typedef struct  {                                                                
  char name[10];                  //jmeno pole
  char Null1;
  char Typ ;                      //typ C,N,L,D,M
  int  Null2;
  char Width;                     //sirka pole v bytech
  char Decimal;                   //pocet d.m.
  char shrot[14];               
} tfield;

tfield field[20];

typedef struct {
  int Null1;                  //4 bytes
  int RecordNumber;           //4 bytes
  unsigned short DataOffset;  //2 bytes
  unsigned short RecordSize;  //2 bytes
} tdbfheader;

tdbfheader dbfheader;

typedef struct {
  char *name;
  FILE *dbffile;
  tdbfheader dbfheader;
  tfield field[20];
  int max_field;

  FILE *translation_table;
  unsigned char tab[256];
 
} tdatabase;

typedef struct {
  char *name;
  FILE *index_file;
  int is_valid;
  unsigned int index_table[256];
} tindex;

int open_database(char *name, tdatabase *d);
int close_database(tdatabase *d);
int use_database(tdatabase *d);

int check_fields(tdatabase *d);
int seek_to_row(int which, tdatabase *d);
char * get_column(int which);
int seek_for(char *string, tdatabase *d);

int get_start(char c, tindex *index);

int read_index_table(char *name, tindex *index);
int read_translation_table(char *name, tdatabase *d);

int create_index(char * database_name, char * index_name);
